toml-parser-1.3.0.0: TOML 1.0.0 parser

Copyright | (c) Eric Mertens 2023
License | ISC
Maintainer | emertens@gmail.com
Safe Haskell | Safe-Inferred
Language | Haskell2010

Toml.Value

Description

This module provides the type for the semantics of a TOML file. All dotted keys are resolved in this representation. Each table is a Map with a single level of keys.

Synopsis

- data Value
  - = Integer Integer
  - | Float Double
  - | Array [Value]
  - | Table Table
  - | Bool Bool
  - | String String
  - | TimeOfDay TimeOfDay
  - | ZonedTime ZonedTime
  - | LocalTime LocalTime
  - | Day Day
- type Table = Map String Value

# Documentation

data Value #

Semantic TOML value with all table assignments resolved.

Constructors

Integer Integer |
Float Double |
Array [Value] |
Table Table |
Bool Bool |
String String |
TimeOfDay TimeOfDay |
ZonedTime ZonedTime |
LocalTime LocalTime |
Day Day |

#### Instances

Instances details

Data Value # | Default instance

Instance details

Defined in Toml.Value

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Value -> c Value

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Value

toConstr :: Value -> Constr

dataTypeOf :: Value -> DataType

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Value)

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Value)

gmapT :: (forall b. Data b => b -> b) -> Value -> Value

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Value -> r

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Value -> r

gmapQ :: (forall d. Data d => d -> u) -> Value -> [u]

gmapQi :: Int -> (forall d. Data d => d -> u) -> Value -> u

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Value -> m Value

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Value -> m Value

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Value -> m Value

Generic Value # |
Instance details Defined in Toml.Value Associated Types type Rep Value :: Type -> Type Methods from :: Value -> Rep Value x to :: Rep Value x -> Value
Read Value # | Default instance
Instance details Defined in Toml.Value Methods readsPrec :: Int -> ReadS Value readList :: ReadS [Value] readPrec :: ReadPrec Value readListPrec :: ReadPrec [Value]
Show Value # | Default instance
Instance details Defined in Toml.Value Methods showsPrec :: Int -> Value -> ShowS show :: Value -> String showList :: [Value] -> ShowS
Eq Value # | Nearly default instance except `Value` doesn't have an `Eq` instance. `Value` values are equal if their times and timezones are both equal.
Instance details Defined in Toml.Value Methods (==) :: Value -> Value -> Bool (/=) :: Value -> Value -> Bool
FromValue Value # | Matches all values, used for pass-through
Instance details Defined in Toml.FromValue Methods fromValue :: Value -> Matcher Value # listFromValue :: Value -> Matcher [Value] #
ToValue Value # | Identity function
Instance details Defined in Toml.ToValue Methods toValue :: Value -> Value # toValueList :: [Value] -> Value #
type Rep Value # | Default instance

Instance details

Defined in Toml.Value

type Rep Value = D1 ('MetaData "Value" "Toml.Value" "toml-parser-1.3.0.0-CYT1F0M7m7w5Wflta0pWOu" 'False) (((C1 ('MetaCons "Integer" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Integer)) :+: C1 ('MetaCons "Float" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Double))) :+: (C1 ('MetaCons "Array" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 [Value])) :+: (C1 ('MetaCons "Table" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Table)) :+: C1 ('MetaCons "Bool" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Bool))))) :+: ((C1 ('MetaCons "String" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 String)) :+: C1 ('MetaCons "TimeOfDay" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 TimeOfDay))) :+: (C1 ('MetaCons "ZonedTime" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 ZonedTime)) :+: (C1 ('MetaCons "LocalTime" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 LocalTime)) :+: C1 ('MetaCons "Day" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'NoSourceUnpackedness 'NoSourceStrictness 'DecidedLazy) (Rec0 Day))))))

type Table = Map String Value #

Representation of a TOML key-value table.